package day1_test

import (
	"bytes"
	"fmt"
	"log"
	"os"
	"path/filepath"
	"testing"

	"source.toby3d.me/toby3d/adventofcode/internal/day1/part1"
	"source.toby3d.me/toby3d/adventofcode/internal/day1/part2"
)

var input []byte

func TestMain(m *testing.M) {
	var err error
	if input, err = os.ReadFile(filepath.Join("testdata", "input")); err != nil {
		log.Fatalln("cannot open input file:", err)
	}

	os.Exit(m.Run())
}

func Example() {
	result, err := part1.Calibrate(bytes.NewReader(input))
	if err != nil {
		log.Fatalln("cannot sum all calibration values:", err)
	}

	fmt.Println(result)
	// Output: 54601
}

func Example_PartTwo() {
	result, err := part2.Calibrate(bytes.NewReader(input))
	if err != nil {
		log.Fatalln("cannot sum all calibration values:", err)
	}

	fmt.Println(result)
	// Output: 54078
}
