package part1_test

import (
	"fmt"
	"log"
	"strings"

	"source.toby3d.me/toby3d/adventofcode/internal/day1/part1"
)

func Example() {
	var sum uint = 0

	// The newly-improved calibration document consists of lines of text;
	// each line originally contained a specific calibration value that the
	// Elves now need to recover. On each line, the calibration value can be
	// found by combining the first digit and the last digit (in that order)
	// to form a single two-digit number.
	for _, exampleLine := range []string{
		"1abc2",
		"pqr3stu8vwx",
		"a1b2c3d4e5f",
		"treb7uchet",
	} {
		calibrationValue, err := part1.Calibrate(strings.NewReader(exampleLine))
		if err != nil {
			log.Fatalln(err)
		}

		sum += calibrationValue

		fmt.Println(calibrationValue)
	}

	// Adding these together produces 142.
	fmt.Println(sum)

	// Output:
	// 12
	// 38
	// 15
	// 77
	// 142
}
