package part2_test

import (
	"fmt"
	"log"
	"strings"

	"source.toby3d.me/toby3d/adventofcode/internal/day1/part2"
)

func Example() {
	var sum uint = 0

	// It looks like some of the digits are actually spelled out with
	// letters: one, two, three, four, five, six, seven, eight, and nine
	// also count as valid "digits".
	for _, exampleLine := range []string{
		"two1nine",
		"eightwothree",
		"abcone2threexyz",
		"xtwone3four",
		"4nineeightseven2",
		"zoneight234",
		"7pqrstsixteen",
	} {
		calibrationValue, err := part2.Calibrate(strings.NewReader(exampleLine))
		if err != nil {
			log.Fatalln(err)
		}

		sum += calibrationValue

		fmt.Println(calibrationValue)
	}

	fmt.Println(sum)

	// Output:
	// 29
	// 83
	// 13
	// 24
	// 42
	// 14
	// 76
	// 281
}
