package day15

import (
	"bytes"
	"fmt"
	"log"
	"os"
	"path/filepath"
	"testing"

	"source.toby3d.me/toby3d/adventofcode/internal/day15/part1"
	"source.toby3d.me/toby3d/adventofcode/internal/day15/part2"
)

var input []byte

func TestMain(m *testing.M) {
	var err error
	if input, err = os.ReadFile(filepath.Join("testdata", "input")); err != nil {
		log.Fatalln("cannot open input file:", err)
	}

	os.Exit(m.Run())
}

func Example() {
	fmt.Println(part1.ParseSequence(bytes.NewReader(input)).Sum())
	// Output: 514639
}

func Example_PartTwo() {
	fmt.Println(part2.ParseSequence(bytes.NewReader(input)).Sum())
	// Output: 279470
}
