package part1

import (
	"bufio"
	"io"
)

type (
	Sequence []Step
	Step     []byte
)

func (s Step) Sum() uint {
	var result uint

	for i := range s {
		result += uint(s[i])
		result *= 17
		result = result % 256
	}

	return result
}

func (s Sequence) Sum() uint {
	var result uint

	for i := range s {
		result += s[i].Sum()
	}

	return result
}

func ParseSequence(r io.Reader) Sequence {
	scanner := bufio.NewScanner(r)
	scanner.Split(bufio.ScanBytes)

	seq := make(Sequence, 0)
	step := make(Step, 0)

	for scanner.Scan() {
		b := scanner.Bytes()[0]
		switch b {
		case ',', '\n':
			seq = append(seq, step)
			step = make(Step, 0)

			continue
		}

		step = append(step, b)
	}

	return seq
}
