package part1_test

import (
	"fmt"
	"strings"
	"testing"

	"source.toby3d.me/toby3d/adventofcode/internal/day15/part1"
)

func TestStep_Sum(t *testing.T) {
	t.Parallel()

	const expect uint = 52

	step := part1.Step("HASH")
	if actual := step.Sum(); actual != expect {
		t.Errorf("want %d, got %d", expect, actual)
	}
}

func Example() {
	input := "rn=1,cm-,qp=3,cm=2,qp-,pc=4,ot=9,ab=5,pc-,pc=6,ot=7\n"
	seq := part1.ParseSequence(strings.NewReader(input))

	for i := range seq {
		fmt.Println(string(seq[i]), "becomes", seq[i].Sum())
	}

	fmt.Println(seq.Sum())
	// Output:
	// rn=1 becomes 30
	// cm- becomes 253
	// qp=3 becomes 97
	// cm=2 becomes 47
	// qp- becomes 14
	// pc=4 becomes 180
	// ot=9 becomes 9
	// ab=5 becomes 197
	// pc- becomes 48
	// pc=6 becomes 214
	// ot=7 becomes 231
	// 1320
}
