package day2_test

import (
	"bytes"
	"fmt"
	"log"
	"os"
	"path/filepath"
	"testing"

	"source.toby3d.me/toby3d/adventofcode/internal/day2/part1"
	"source.toby3d.me/toby3d/adventofcode/internal/day2/part2"
)

var input []byte

func TestMain(m *testing.M) {
	var err error
	if input, err = os.ReadFile(filepath.Join("testdata", "input")); err != nil {
		log.Fatalln("cannot open input file:", err)
	}

	os.Exit(m.Run())
}

func Example() {
	result, err := part1.GetSecretNumber(bytes.NewReader(input), part1.Bag{
		Red:   12,
		Green: 13,
		Blue:  14,
	})
	if err != nil {
		log.Fatalln("cannot get secret number:", err)
	}

	fmt.Println(result)
	// Output: 3035
}

func Example_PartTwo() {
	result, err := part2.GetPowerSum(bytes.NewReader(input))
	if err != nil {
		log.Fatalln("cannot get power sum:", err)
	}

	fmt.Println(result)
	// Output: 66027
}
