package day3_test

import (
	"bytes"
	"fmt"
	"log"
	"os"
	"path/filepath"
	"testing"

	"source.toby3d.me/toby3d/adventofcode/internal/day3/part1"
	"source.toby3d.me/toby3d/adventofcode/internal/day3/part2"
)

var input []byte

func TestMain(m *testing.M) {
	var err error
	if input, err = os.ReadFile(filepath.Join("testdata", "input")); err != nil {
		log.Fatalln("cannot open input file:", err)
	}

	os.Exit(m.Run())
}

func Example() {
	fmt.Println(part1.GetPartNumbersSum(bytes.NewReader(input)))
	// Output: 540025
}

func Example_PartTwo() {
	fmt.Println(part2.ParseEngineMap(bytes.NewReader(input)).GetGearRatiosSum())
	// Output: 84584891
}
