package day4_test

import (
	"bytes"
	"fmt"
	"log"
	"os"
	"path/filepath"
	"testing"

	"source.toby3d.me/toby3d/adventofcode/internal/day4/part1"
	"source.toby3d.me/toby3d/adventofcode/internal/day4/part2"
)

var input []byte

func TestMain(m *testing.M) {
	var err error
	if input, err = os.ReadFile(filepath.Join("testdata", "input")); err != nil {
		log.Fatalln("cannot open input file:", err)
	}

	os.Exit(m.Run())
}

func Example() {
	result, err := part1.GetTotalWorthPoints(bytes.NewReader(input))
	if err != nil {
		log.Fatalln("cannot get total worth:", err)
	}

	fmt.Println(result)
	// Output: 32001
}

func Example_PartTwo() {
	result, err := part2.GetTotalScratchcards(bytes.NewReader(input))
	if err != nil {
		log.Fatalln("cannot get total count of scratchcards:", err)
	}

	fmt.Println(result)
	// Output: 5037841
}
