package day5_test

import (
	"bytes"
	"fmt"
	"log"
	"os"
	"path/filepath"
	"testing"

	"source.toby3d.me/toby3d/adventofcode/internal/day5/part1"
	"source.toby3d.me/toby3d/adventofcode/internal/day5/part2"
)

var input []byte

func TestMain(m *testing.M) {
	var err error
	if input, err = os.ReadFile(filepath.Join("testdata", "input")); err != nil {
		log.Fatalln("cannot open input file:", err)
	}

	os.Exit(m.Run())
}

func Example() {
	almanac, err := part1.ParseAlmanac(bytes.NewReader(input))
	if err != nil {
		log.Fatalln("cannot parse almanac:", err)
	}

	fmt.Println(almanac.FindLowestLocation())
	// Output: 551761867
}

func Example_PartTwo() {
	almanac, err := part2.ParseAlmanac(bytes.NewReader(input))
	if err != nil {
		log.Fatalln("cannot parse almanac:", err)
	}

	// WARN(toby3d): Extremely slow! Took ~209 seconds to run, but returned
	// the correct result BY ANY PRICE, BUT FREE.
	fmt.Println(almanac.FindLowestLocation())
	// Output: 57451709
}
