package day7_test

import (
	"bytes"
	"fmt"
	"log"
	"os"
	"path/filepath"
	"testing"

	"source.toby3d.me/toby3d/adventofcode/internal/day7/part1"
	"source.toby3d.me/toby3d/adventofcode/internal/day7/part2"
)

var input []byte

func TestMain(m *testing.M) {
	var err error
	if input, err = os.ReadFile(filepath.Join("testdata", "input")); err != nil {
		log.Fatalln("cannot open input file:", err)
	}

	os.Exit(m.Run())
}

func Example() {
	camelCards, err := part1.ParseCamelCards(bytes.NewReader(input))
	if err != nil {
		log.Fatalln("cannot parse Camel Cards list:", err)
	}

	fmt.Println(camelCards.CountTotalWinnings())
	// Output: 246795406
}

func Example_PartTwo() {
	camelCards, err := part2.ParseCamelCards(bytes.NewReader(input))
	if err != nil {
		log.Fatalln("cannot parse Camel Cards list:", err)
	}

	fmt.Println(camelCards.CountTotalWinnings())
	// Output: 249356515
}
