package day8_test

import (
	"bytes"
	"fmt"
	"log"
	"os"
	"path/filepath"
	"testing"

	"source.toby3d.me/toby3d/adventofcode/internal/day8/part1"
	"source.toby3d.me/toby3d/adventofcode/internal/day8/part2"
)

var input []byte

func TestMain(m *testing.M) {
	var err error
	if input, err = os.ReadFile(filepath.Join("testdata", "input")); err != nil {
		log.Fatalln("cannot open input file:", err)
	}

	os.Exit(m.Run())
}

func Example() {
	fmt.Println(part1.ParseNetworkMap(bytes.NewReader(input)).CountSteps())
	// Output: 19631
}

func Example_PartTwo() {
	fmt.Println(part2.ParseNetworkMap(bytes.NewReader(input)).CountSteps())
	// Output: 21003205388413
}
