package day9_test

import (
	"bytes"
	"fmt"
	"log"
	"os"
	"path/filepath"
	"testing"

	"source.toby3d.me/toby3d/adventofcode/internal/day9/part1"
	"source.toby3d.me/toby3d/adventofcode/internal/day9/part2"
)

var input []byte

func TestMain(m *testing.M) {
	var err error
	if input, err = os.ReadFile(filepath.Join("testdata", "input")); err != nil {
		log.Fatalln("cannot open input file:", err)
	}

	os.Exit(m.Run())
}

func Example() {
	report, err := part1.ParseReport(bytes.NewReader(input))
	if err != nil {
		log.Fatalln(err)
	}

	fmt.Println(report.Sum())
	// Output: 1641934234
}

func Example_PartTwo() {
	report, err := part2.ParseReport(bytes.NewReader(input))
	if err != nil {
		log.Fatalln(err)
	}

	fmt.Println(report.Sum())
	// Output: 975
}
